=== debian/changelog ===
gnucash-docs (4.12-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.1.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 18 Oct 2022 14:43:10 +1100
